//+------------------------------------------------------------------+
//|                                                    functions.mq4 |
//|                                 Copyright  2015 by Mike Zhitnev |
//|                                           http://Forex-Robots.ru |
//| EA/Scripts/Indicators programming ::::    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015 by Mike Zhitnev"
#property link      "http://Forex-Robots.ru"

#property strict
#include <stdlib.mqh>
#include <WinUser32.mqh>

extern string    stG = "::: General settings :::";
extern int       Profit = 50;  // Profit, $
extern int       Loss = -30;   // Loss, $
extern double    Lots=0.1;           
extern int       Slippage=2;         
extern int       Delta = 20;   // Distance between two orders
extern int       BreakEven = -30; //Breakeven, $
       
       datetime    DateExpiration = D'2015.12.23' ;   
       int         AccountNum = 155059;   

int TakeProfit, StopLoss;
int Magic = 0;   
bool FirstTime = False;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   Comment("wait...");
   //int Ticket = OrderSend(Symbol(), OP_BUY, 0.1, Ask, Slippage, 0, 0, "", Magic, 0 ,Red); 
   FirstTime = False;
   return(INIT_SUCCEEDED);
  }
  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int PrintError(int Part)
  {
    int error = GetLastError();
    if (error!=0) 
    {
      Print("Part " + IntegerToString(Part) + "; Error " + IntegerToString(error) + ": " + ErrorDescription(error));
      PlaySound("alert.wav");
    }  
    return(error);
  } 

//+---------------------------------------------------------------------------------------+
//|     TYPE,    -1    |
//+---------------------------------------------------------------------------------------+
int OrderExists(int Type)
  {
    if (OrdersTotal()==0) return(-1);
    for (int i=0; i<OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderType()==Type && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) return(OrderTicket());
    return(-1);  
  }  
  
//+------------------------------------------------------------------+
//|    ,           |
//+------------------------------------------------------------------+
int TotalOrders()
  {        
    int n=0;
    for (int i=0; i<OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==Magic && OrderSymbol()==Symbol()) n++;
    return(n);  
  }  
  
//+-----------------------------------------------------------------------------+
//|     ,             |
//+-----------------------------------------------------------------------------+
int TotalMarketOrders()
  {    
    int n=0;
    for (int i=0; i<OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==Magic && OrderSymbol()==Symbol() && OrderType()<=1) n++;
    return(n);  
  }    

//+----------------------------------------------------------------------+
//|   SELL   SL  TP,     |
//+----------------------------------------------------------------------+
void Sell(string comm)
  {
      double op=0, sl=0, tp=0; 
      op = NormalizeDouble(Bid,Digits);   
      //if (Risk!=0) Lots = NormalizeDouble( AccountBalance()*0.001*Risk, 2);       
      Print("Putting SELL-order (v=" + DoubleToStr(Lots, 2) +"), prices: OP=" + DoubleToStr(op,Digits) +"; SL=" + DoubleToStr(sl,Digits) + "; TP=" + DoubleToStr(tp,Digits));
      int Ticket = OrderSend(Symbol(), OP_SELL, Lots, op, Slippage, 0, 0, comm, Magic, 0 ,Red); 
      if (PrintError(329)==0 && OrderSelect( Ticket, SELECT_BY_TICKET)==true)
      {
        //SendMail("Sapsan " + AccountNumber() + " " + Symbol(),"New SELL-order #"+Ticket+" was opened; Equity=" + DoubleToStr(AccountEquity(),0));        
        op = NormalizeDouble(OrderOpenPrice(),Digits);          
        tp = NormalizeDouble(op - (TakeProfit)*Point,Digits);   
        if (TakeProfit==0) tp=0;   
        sl = NormalizeDouble(op + (StopLoss)*Point,Digits);                              
        if (StopLoss==0) sl=0;
        if (sl!=0 || tp!=0) 
        {
          Print("Modifying SELL-order # #" + IntegerToString(Ticket));
          if (OrderModify( Ticket, op, sl, tp, 0, Yellow)==false)    
            PrintError(340);                                               
        }  
      }            
  }

//+------------------------------------------------------------------+
//|   BUY                                                |
//+------------------------------------------------------------------+
void Buy(string comm)
  {
      double op=0, sl=0, tp=0; 
      op = NormalizeDouble(Ask,Digits);         
      //if (Risk!=0) Lots = NormalizeDouble( AccountBalance()*0.001*Risk, 2);
      Print("Putting BUY-order (v=" + DoubleToStr(Lots, 2) +"), prices: OP=" + DoubleToStr(op,Digits) +"; SL=" + DoubleToStr(sl,Digits) + "; TP=" + DoubleToStr(tp,Digits));
      int Ticket = OrderSend(Symbol(), OP_BUY, Lots, op, Slippage, 0, 0, comm, Magic, 0 ,Blue); 
      if (PrintError(357)==0 && OrderSelect( Ticket, SELECT_BY_TICKET)==true)
      {
        //SendMail("Sapsan " + AccountNumber() + " " + Symbol(),"New BUY-order #"+Ticket+" was opened; Equity=" + DoubleToStr(AccountEquity(),0));        
        op = NormalizeDouble(OrderOpenPrice(),Digits);          
        tp = NormalizeDouble(op + (TakeProfit)*Point,Digits);      
        if (TakeProfit==0) tp=0;
        sl = NormalizeDouble(op - (StopLoss)*Point,Digits);   
        if (StopLoss==0) sl=0;
        if (sl!=0 || tp!=0) 
        {
          Print("Modifying BUY-order #" + IntegerToString(Ticket));
          if (OrderModify( Ticket, op, sl, tp, 0, Yellow)==false)    
            PrintError(369);                                               
        }  
      }        
  }

//+------------------------------------------------------------------+
//|   ,                     |
//+------------------------------------------------------------------+
double EA_orders_equity()
  {
    double sum=0;
    for (int i=0; i<OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==Magic && OrderSymbol()==Symbol()) 
      {
        sum = sum + OrderProfit() + OrderSwap() + OrderCommission();
      }
    return(sum);  
  }

//+-------------------------------------------------------------------------------------+
//|  ,                                  |
//+-------------------------------------------------------------------------------------+
void CloseAllOrders()
  {        
    int A;
    while (TotalOrders()>0)
      for (int i=0; i<=OrdersTotal(); i++)
        if (OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber()==Magic && OrderSymbol()==Symbol())
        {                 
          RefreshRates();
          if (OrderType()==OP_BUY)  if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Blue)==false) A++;
          if (OrderType()==OP_SELL) if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Red)==false) A++;
          if (OrderType()>1) if (OrderDelete(OrderTicket())==false) A++;
          if (PrintError(558)==0) PlaySound("tick.wav");               
        }      
  }  

//+------------------------------------------------------------------+
//|       Comm         |
//+------------------------------------------------------------------+
int FindOrder(string Comm)
  {
    if (OrdersTotal()==0) return(false);
    for (int i=0; i<=OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderComment()==Comm) 
      {
        //Print("Order with Comment=" + Comm + " was found" );
        return(OrderTicket());
      }  
    return(-1);  
  }

//+------------------------------------------------------------------+
//| ,                                      |
//+------------------------------------------------------------------+
/*
bool GetKey()
  {
    // :
    //   (0..99)
    //   (  +1)
    //    - ,   x2
    //XX.YYYYYY.ZZZZZZ
    if (Key=="qazxsw") return(true);
    string stL = StringSubstr(Key,0,2);  //     
    int L = StrToInteger(stL);
    string stA = StringSubstr(Key,2,L);  //
    string stB;
    for (int i=0; i<StringLen(stA); i++)
    {      
      string ST = StringSubstr(stA,i,1);
      
      if (ST=="0") stB = stB + "1";
      else
      if (ST=="1") stB = stB + "2";
      else
      if (ST=="2") stB = stB + "3";
      else
      if (ST=="3") stB = stB + "4";
      else
      if (ST=="4") stB = stB + "5";
      else
      if (ST=="5") stB = stB + "6";
      else
      if (ST=="6") stB = stB + "7";
      else
      if (ST=="7") stB = stB + "8";
      else
      if (ST=="8") stB = stB + "9";
      else
      if (ST=="9") stB = stB + "0";
    }     
    string stD = StringSubstr(Key,2+L);  //
    int DT = StrToInteger(stD);    
    //Print(": " + DT + ";  : " + TimeCurrent());
    //Print(" : " + L);
    //Print(" : " + stB);
    if (AccountNumber()!=StrToInteger(stB)) 
    {
      //Print(" !");
      return(false);
    }
    if (TimeCurrent()>DT) 
    {
      //Print(" !");
      return(false);
    }   
    //Print(" ");     
    return(true);
  }
*/
  
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
     
    if (AccountNumber()!=AccountNum)
    {
      Comment("you are not authorized to use this EA, contact hardeepdhruv@gmail.com");
      if (FirstTime==false) Alert("you are not authorized to use this EA, contact hardeepdhruv@gmail.com");
      FirstTime = true;
      return;
    }
    
    if (TimeCurrent()>=DateExpiration)
    {
      Comment("EA expired please contact hardeepdhruv@gmail.com");
      if (FirstTime==false) Alert("EA expired please contact hardeepdhruv@gmail.com");
      FirstTime = true;
      return;
    }    

    string st7;
    double PP = EA_orders_equity();
    if (PP>=0) st7 = "Profit: "; else st7 = "Loss: ";
   
    if (ObjectFind("FLOATING")==-1) ObjectCreate("FLOATING", OBJ_LABEL, 0, 0, 0);
    ObjectSetText("FLOATING", st7 + DoubleToStr(PP,2) + "$", 20, "Arial", White);
    ObjectSet("FLOATING", OBJPROP_CORNER, 0);
    ObjectSet("FLOATING", OBJPROP_XDISTANCE, 10);
    ObjectSet("FLOATING", OBJPROP_YDISTANCE, 55);   
              
     if (TotalMarketOrders()==0) Comment("EA is waiting for the first manual order...");
     
     if (TotalMarketOrders()==1)
     {       
       Comment("Checking for the Delta distance...\nProfit: " + DoubleToString(EA_orders_equity(),2) + "$");
       int Ticket = OrderExists(OP_BUY);
       if (Ticket>0 && OrderSelect(Ticket, SELECT_BY_TICKET) && Ask>=OrderOpenPrice()+Delta*Point) Buy("XXX");
       Ticket = OrderExists(OP_SELL);
       if (Ticket>0 && OrderSelect(Ticket, SELECT_BY_TICKET) && Bid<=OrderOpenPrice()-Delta*Point) Sell("XXX");       
     }
     
     if (TotalMarketOrders()==2)
     {
       Comment("Waiting for the Profit/Loss/BreakEven events...\nProfit: " + DoubleToString(EA_orders_equity(),2) + "$");
      
       if (EA_orders_equity()<=BreakEven) 
       {
         Print(Symbol() + ": Loss=" + DoubleToString(BreakEven,2) + "$ is reached, closing all orders");
         CloseAllOrders();
       } 
      
         /*
         int Ticket = FindOrder("XXX");
         if (Ticket>0 && OrderSelect(Ticket, SELECT_BY_TICKET) && OrderProfit()<=BreakEven) 
         {
           Print(Symbol() + ": BreakEven for order #" + IntegerToString(OrderTicket()) + " is reached, closing all orders");
           CloseAllOrders();          
         }
         */              
     }
     
     //if (TotalMarketOrders()==2)
     //{
       if (EA_orders_equity()>=Profit) 
       {
         Print(Symbol() + ": Profit=" + DoubleToString(Profit,2) + " is reached, closing all orders");
         CloseAllOrders();
       } 
       if (EA_orders_equity()<=Loss) 
       {
         Print(Symbol() + ": Loss=" + DoubleToString(Loss,2) + " is reached, closing all orders");
         CloseAllOrders();
       } 
     //} 
        
  }
//+------------------------------------------------------------------+
